// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// - protoc-gen-go-grpc v1.3.0
// - protoc             v3.20.3
// source: services.proto

package interfaces

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

const (
	ApiServices_GetListener_FullMethodName       = "/proxy.ApiServices/GetListener"
	ApiServices_AddListener_FullMethodName       = "/proxy.ApiServices/AddListener"
	ApiServices_RemoveListener_FullMethodName    = "/proxy.ApiServices/RemoveListener"
	ApiServices_AddRouting_FullMethodName        = "/proxy.ApiServices/AddRouting"
	ApiServices_GetRouting_FullMethodName        = "/proxy.ApiServices/GetRouting"
	ApiServices_GetBackend_FullMethodName        = "/proxy.ApiServices/GetBackend"
	ApiServices_GetServer_FullMethodName         = "/proxy.ApiServices/GetServer"
	ApiServices_AddBackend_FullMethodName        = "/proxy.ApiServices/AddBackend"
	ApiServices_RemoveRouting_FullMethodName     = "/proxy.ApiServices/RemoveRouting"
	ApiServices_RemoveBackend_FullMethodName     = "/proxy.ApiServices/RemoveBackend"
	ApiServices_RemoveServer_FullMethodName      = "/proxy.ApiServices/RemoveServer"
	ApiServices_AddServer_FullMethodName         = "/proxy.ApiServices/AddServer"
	ApiServices_RemoveAllListener_FullMethodName = "/proxy.ApiServices/RemoveAllListener"
	ApiServices_RemoveAllRouting_FullMethodName  = "/proxy.ApiServices/RemoveAllRouting"
	ApiServices_RemoveAllBackend_FullMethodName  = "/proxy.ApiServices/RemoveAllBackend"
	ApiServices_RemoveAllServer_FullMethodName   = "/proxy.ApiServices/RemoveAllServer"
	ApiServices_SuspendServer_FullMethodName     = "/proxy.ApiServices/SuspendServer"
	ApiServices_ProxyInfo_FullMethodName         = "/proxy.ApiServices/ProxyInfo"
)

// ApiServicesClient is the client API for ApiServices service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type ApiServicesClient interface {
	GetListener(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*GetListenerResponse, error)
	AddListener(ctx context.Context, in *Listener, opts ...grpc.CallOption) (*emptypb.Empty, error)
	RemoveListener(ctx context.Context, in *RemoveListenerRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
	AddRouting(ctx context.Context, in *Routing, opts ...grpc.CallOption) (*emptypb.Empty, error)
	GetRouting(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*GetRoutingResponse, error)
	GetBackend(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*GetBackendResponse, error)
	GetServer(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*GetServerResponse, error)
	AddBackend(ctx context.Context, in *Backend, opts ...grpc.CallOption) (*emptypb.Empty, error)
	RemoveRouting(ctx context.Context, in *RemoveRoutingRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
	RemoveBackend(ctx context.Context, in *RemoveBackendRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
	RemoveServer(ctx context.Context, in *RemoveServerRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
	AddServer(ctx context.Context, in *Server, opts ...grpc.CallOption) (*emptypb.Empty, error)
	RemoveAllListener(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*emptypb.Empty, error)
	RemoveAllRouting(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*emptypb.Empty, error)
	RemoveAllBackend(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*emptypb.Empty, error)
	RemoveAllServer(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*emptypb.Empty, error)
	SuspendServer(ctx context.Context, in *SuspendServerRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
	ProxyInfo(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*ProxyInfoResponse, error)
}

type apiServicesClient struct {
	cc grpc.ClientConnInterface
}

func NewApiServicesClient(cc grpc.ClientConnInterface) ApiServicesClient {
	return &apiServicesClient{cc}
}

func (c *apiServicesClient) GetListener(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*GetListenerResponse, error) {
	out := new(GetListenerResponse)
	err := c.cc.Invoke(ctx, ApiServices_GetListener_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *apiServicesClient) AddListener(ctx context.Context, in *Listener, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, ApiServices_AddListener_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *apiServicesClient) RemoveListener(ctx context.Context, in *RemoveListenerRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, ApiServices_RemoveListener_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *apiServicesClient) AddRouting(ctx context.Context, in *Routing, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, ApiServices_AddRouting_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *apiServicesClient) GetRouting(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*GetRoutingResponse, error) {
	out := new(GetRoutingResponse)
	err := c.cc.Invoke(ctx, ApiServices_GetRouting_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *apiServicesClient) GetBackend(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*GetBackendResponse, error) {
	out := new(GetBackendResponse)
	err := c.cc.Invoke(ctx, ApiServices_GetBackend_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *apiServicesClient) GetServer(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*GetServerResponse, error) {
	out := new(GetServerResponse)
	err := c.cc.Invoke(ctx, ApiServices_GetServer_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *apiServicesClient) AddBackend(ctx context.Context, in *Backend, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, ApiServices_AddBackend_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *apiServicesClient) RemoveRouting(ctx context.Context, in *RemoveRoutingRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, ApiServices_RemoveRouting_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *apiServicesClient) RemoveBackend(ctx context.Context, in *RemoveBackendRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, ApiServices_RemoveBackend_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *apiServicesClient) RemoveServer(ctx context.Context, in *RemoveServerRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, ApiServices_RemoveServer_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *apiServicesClient) AddServer(ctx context.Context, in *Server, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, ApiServices_AddServer_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *apiServicesClient) RemoveAllListener(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, ApiServices_RemoveAllListener_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *apiServicesClient) RemoveAllRouting(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, ApiServices_RemoveAllRouting_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *apiServicesClient) RemoveAllBackend(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, ApiServices_RemoveAllBackend_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *apiServicesClient) RemoveAllServer(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, ApiServices_RemoveAllServer_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *apiServicesClient) SuspendServer(ctx context.Context, in *SuspendServerRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, ApiServices_SuspendServer_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *apiServicesClient) ProxyInfo(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*ProxyInfoResponse, error) {
	out := new(ProxyInfoResponse)
	err := c.cc.Invoke(ctx, ApiServices_ProxyInfo_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// ApiServicesServer is the server API for ApiServices service.
// All implementations must embed UnimplementedApiServicesServer
// for forward compatibility
type ApiServicesServer interface {
	GetListener(context.Context, *emptypb.Empty) (*GetListenerResponse, error)
	AddListener(context.Context, *Listener) (*emptypb.Empty, error)
	RemoveListener(context.Context, *RemoveListenerRequest) (*emptypb.Empty, error)
	AddRouting(context.Context, *Routing) (*emptypb.Empty, error)
	GetRouting(context.Context, *emptypb.Empty) (*GetRoutingResponse, error)
	GetBackend(context.Context, *emptypb.Empty) (*GetBackendResponse, error)
	GetServer(context.Context, *emptypb.Empty) (*GetServerResponse, error)
	AddBackend(context.Context, *Backend) (*emptypb.Empty, error)
	RemoveRouting(context.Context, *RemoveRoutingRequest) (*emptypb.Empty, error)
	RemoveBackend(context.Context, *RemoveBackendRequest) (*emptypb.Empty, error)
	RemoveServer(context.Context, *RemoveServerRequest) (*emptypb.Empty, error)
	AddServer(context.Context, *Server) (*emptypb.Empty, error)
	RemoveAllListener(context.Context, *emptypb.Empty) (*emptypb.Empty, error)
	RemoveAllRouting(context.Context, *emptypb.Empty) (*emptypb.Empty, error)
	RemoveAllBackend(context.Context, *emptypb.Empty) (*emptypb.Empty, error)
	RemoveAllServer(context.Context, *emptypb.Empty) (*emptypb.Empty, error)
	SuspendServer(context.Context, *SuspendServerRequest) (*emptypb.Empty, error)
	ProxyInfo(context.Context, *emptypb.Empty) (*ProxyInfoResponse, error)
	mustEmbedUnimplementedApiServicesServer()
}

// UnimplementedApiServicesServer must be embedded to have forward compatible implementations.
type UnimplementedApiServicesServer struct {
}

func (UnimplementedApiServicesServer) GetListener(context.Context, *emptypb.Empty) (*GetListenerResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetListener not implemented")
}
func (UnimplementedApiServicesServer) AddListener(context.Context, *Listener) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method AddListener not implemented")
}
func (UnimplementedApiServicesServer) RemoveListener(context.Context, *RemoveListenerRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method RemoveListener not implemented")
}
func (UnimplementedApiServicesServer) AddRouting(context.Context, *Routing) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method AddRouting not implemented")
}
func (UnimplementedApiServicesServer) GetRouting(context.Context, *emptypb.Empty) (*GetRoutingResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetRouting not implemented")
}
func (UnimplementedApiServicesServer) GetBackend(context.Context, *emptypb.Empty) (*GetBackendResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetBackend not implemented")
}
func (UnimplementedApiServicesServer) GetServer(context.Context, *emptypb.Empty) (*GetServerResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetServer not implemented")
}
func (UnimplementedApiServicesServer) AddBackend(context.Context, *Backend) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method AddBackend not implemented")
}
func (UnimplementedApiServicesServer) RemoveRouting(context.Context, *RemoveRoutingRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method RemoveRouting not implemented")
}
func (UnimplementedApiServicesServer) RemoveBackend(context.Context, *RemoveBackendRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method RemoveBackend not implemented")
}
func (UnimplementedApiServicesServer) RemoveServer(context.Context, *RemoveServerRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method RemoveServer not implemented")
}
func (UnimplementedApiServicesServer) AddServer(context.Context, *Server) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method AddServer not implemented")
}
func (UnimplementedApiServicesServer) RemoveAllListener(context.Context, *emptypb.Empty) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method RemoveAllListener not implemented")
}
func (UnimplementedApiServicesServer) RemoveAllRouting(context.Context, *emptypb.Empty) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method RemoveAllRouting not implemented")
}
func (UnimplementedApiServicesServer) RemoveAllBackend(context.Context, *emptypb.Empty) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method RemoveAllBackend not implemented")
}
func (UnimplementedApiServicesServer) RemoveAllServer(context.Context, *emptypb.Empty) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method RemoveAllServer not implemented")
}
func (UnimplementedApiServicesServer) SuspendServer(context.Context, *SuspendServerRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method SuspendServer not implemented")
}
func (UnimplementedApiServicesServer) ProxyInfo(context.Context, *emptypb.Empty) (*ProxyInfoResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ProxyInfo not implemented")
}
func (UnimplementedApiServicesServer) mustEmbedUnimplementedApiServicesServer() {}

// UnsafeApiServicesServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to ApiServicesServer will
// result in compilation errors.
type UnsafeApiServicesServer interface {
	mustEmbedUnimplementedApiServicesServer()
}

func RegisterApiServicesServer(s grpc.ServiceRegistrar, srv ApiServicesServer) {
	s.RegisterService(&ApiServices_ServiceDesc, srv)
}

func _ApiServices_GetListener_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(emptypb.Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ApiServicesServer).GetListener(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ApiServices_GetListener_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ApiServicesServer).GetListener(ctx, req.(*emptypb.Empty))
	}
	return interceptor(ctx, in, info, handler)
}

func _ApiServices_AddListener_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Listener)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ApiServicesServer).AddListener(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ApiServices_AddListener_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ApiServicesServer).AddListener(ctx, req.(*Listener))
	}
	return interceptor(ctx, in, info, handler)
}

func _ApiServices_RemoveListener_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(RemoveListenerRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ApiServicesServer).RemoveListener(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ApiServices_RemoveListener_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ApiServicesServer).RemoveListener(ctx, req.(*RemoveListenerRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ApiServices_AddRouting_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Routing)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ApiServicesServer).AddRouting(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ApiServices_AddRouting_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ApiServicesServer).AddRouting(ctx, req.(*Routing))
	}
	return interceptor(ctx, in, info, handler)
}

func _ApiServices_GetRouting_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(emptypb.Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ApiServicesServer).GetRouting(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ApiServices_GetRouting_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ApiServicesServer).GetRouting(ctx, req.(*emptypb.Empty))
	}
	return interceptor(ctx, in, info, handler)
}

func _ApiServices_GetBackend_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(emptypb.Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ApiServicesServer).GetBackend(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ApiServices_GetBackend_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ApiServicesServer).GetBackend(ctx, req.(*emptypb.Empty))
	}
	return interceptor(ctx, in, info, handler)
}

func _ApiServices_GetServer_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(emptypb.Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ApiServicesServer).GetServer(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ApiServices_GetServer_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ApiServicesServer).GetServer(ctx, req.(*emptypb.Empty))
	}
	return interceptor(ctx, in, info, handler)
}

func _ApiServices_AddBackend_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Backend)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ApiServicesServer).AddBackend(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ApiServices_AddBackend_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ApiServicesServer).AddBackend(ctx, req.(*Backend))
	}
	return interceptor(ctx, in, info, handler)
}

func _ApiServices_RemoveRouting_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(RemoveRoutingRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ApiServicesServer).RemoveRouting(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ApiServices_RemoveRouting_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ApiServicesServer).RemoveRouting(ctx, req.(*RemoveRoutingRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ApiServices_RemoveBackend_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(RemoveBackendRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ApiServicesServer).RemoveBackend(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ApiServices_RemoveBackend_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ApiServicesServer).RemoveBackend(ctx, req.(*RemoveBackendRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ApiServices_RemoveServer_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(RemoveServerRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ApiServicesServer).RemoveServer(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ApiServices_RemoveServer_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ApiServicesServer).RemoveServer(ctx, req.(*RemoveServerRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ApiServices_AddServer_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Server)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ApiServicesServer).AddServer(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ApiServices_AddServer_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ApiServicesServer).AddServer(ctx, req.(*Server))
	}
	return interceptor(ctx, in, info, handler)
}

func _ApiServices_RemoveAllListener_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(emptypb.Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ApiServicesServer).RemoveAllListener(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ApiServices_RemoveAllListener_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ApiServicesServer).RemoveAllListener(ctx, req.(*emptypb.Empty))
	}
	return interceptor(ctx, in, info, handler)
}

func _ApiServices_RemoveAllRouting_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(emptypb.Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ApiServicesServer).RemoveAllRouting(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ApiServices_RemoveAllRouting_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ApiServicesServer).RemoveAllRouting(ctx, req.(*emptypb.Empty))
	}
	return interceptor(ctx, in, info, handler)
}

func _ApiServices_RemoveAllBackend_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(emptypb.Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ApiServicesServer).RemoveAllBackend(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ApiServices_RemoveAllBackend_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ApiServicesServer).RemoveAllBackend(ctx, req.(*emptypb.Empty))
	}
	return interceptor(ctx, in, info, handler)
}

func _ApiServices_RemoveAllServer_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(emptypb.Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ApiServicesServer).RemoveAllServer(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ApiServices_RemoveAllServer_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ApiServicesServer).RemoveAllServer(ctx, req.(*emptypb.Empty))
	}
	return interceptor(ctx, in, info, handler)
}

func _ApiServices_SuspendServer_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(SuspendServerRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ApiServicesServer).SuspendServer(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ApiServices_SuspendServer_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ApiServicesServer).SuspendServer(ctx, req.(*SuspendServerRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ApiServices_ProxyInfo_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(emptypb.Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ApiServicesServer).ProxyInfo(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ApiServices_ProxyInfo_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ApiServicesServer).ProxyInfo(ctx, req.(*emptypb.Empty))
	}
	return interceptor(ctx, in, info, handler)
}

// ApiServices_ServiceDesc is the grpc.ServiceDesc for ApiServices service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var ApiServices_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "proxy.ApiServices",
	HandlerType: (*ApiServicesServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "GetListener",
			Handler:    _ApiServices_GetListener_Handler,
		},
		{
			MethodName: "AddListener",
			Handler:    _ApiServices_AddListener_Handler,
		},
		{
			MethodName: "RemoveListener",
			Handler:    _ApiServices_RemoveListener_Handler,
		},
		{
			MethodName: "AddRouting",
			Handler:    _ApiServices_AddRouting_Handler,
		},
		{
			MethodName: "GetRouting",
			Handler:    _ApiServices_GetRouting_Handler,
		},
		{
			MethodName: "GetBackend",
			Handler:    _ApiServices_GetBackend_Handler,
		},
		{
			MethodName: "GetServer",
			Handler:    _ApiServices_GetServer_Handler,
		},
		{
			MethodName: "AddBackend",
			Handler:    _ApiServices_AddBackend_Handler,
		},
		{
			MethodName: "RemoveRouting",
			Handler:    _ApiServices_RemoveRouting_Handler,
		},
		{
			MethodName: "RemoveBackend",
			Handler:    _ApiServices_RemoveBackend_Handler,
		},
		{
			MethodName: "RemoveServer",
			Handler:    _ApiServices_RemoveServer_Handler,
		},
		{
			MethodName: "AddServer",
			Handler:    _ApiServices_AddServer_Handler,
		},
		{
			MethodName: "RemoveAllListener",
			Handler:    _ApiServices_RemoveAllListener_Handler,
		},
		{
			MethodName: "RemoveAllRouting",
			Handler:    _ApiServices_RemoveAllRouting_Handler,
		},
		{
			MethodName: "RemoveAllBackend",
			Handler:    _ApiServices_RemoveAllBackend_Handler,
		},
		{
			MethodName: "RemoveAllServer",
			Handler:    _ApiServices_RemoveAllServer_Handler,
		},
		{
			MethodName: "SuspendServer",
			Handler:    _ApiServices_SuspendServer_Handler,
		},
		{
			MethodName: "ProxyInfo",
			Handler:    _ApiServices_ProxyInfo_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "services.proto",
}

const (
	Auth_ValidateToken_FullMethodName = "/proxy.Auth/ValidateToken"
)

// AuthClient is the client API for Auth service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type AuthClient interface {
	ValidateToken(ctx context.Context, in *ValidateTokenRequest, opts ...grpc.CallOption) (*ValidateTokenResponse, error)
}

type authClient struct {
	cc grpc.ClientConnInterface
}

func NewAuthClient(cc grpc.ClientConnInterface) AuthClient {
	return &authClient{cc}
}

func (c *authClient) ValidateToken(ctx context.Context, in *ValidateTokenRequest, opts ...grpc.CallOption) (*ValidateTokenResponse, error) {
	out := new(ValidateTokenResponse)
	err := c.cc.Invoke(ctx, Auth_ValidateToken_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// AuthServer is the server API for Auth service.
// All implementations must embed UnimplementedAuthServer
// for forward compatibility
type AuthServer interface {
	ValidateToken(context.Context, *ValidateTokenRequest) (*ValidateTokenResponse, error)
	mustEmbedUnimplementedAuthServer()
}

// UnimplementedAuthServer must be embedded to have forward compatible implementations.
type UnimplementedAuthServer struct {
}

func (UnimplementedAuthServer) ValidateToken(context.Context, *ValidateTokenRequest) (*ValidateTokenResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ValidateToken not implemented")
}
func (UnimplementedAuthServer) mustEmbedUnimplementedAuthServer() {}

// UnsafeAuthServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to AuthServer will
// result in compilation errors.
type UnsafeAuthServer interface {
	mustEmbedUnimplementedAuthServer()
}

func RegisterAuthServer(s grpc.ServiceRegistrar, srv AuthServer) {
	s.RegisterService(&Auth_ServiceDesc, srv)
}

func _Auth_ValidateToken_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ValidateTokenRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AuthServer).ValidateToken(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Auth_ValidateToken_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AuthServer).ValidateToken(ctx, req.(*ValidateTokenRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// Auth_ServiceDesc is the grpc.ServiceDesc for Auth service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Auth_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "proxy.Auth",
	HandlerType: (*AuthServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "ValidateToken",
			Handler:    _Auth_ValidateToken_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "services.proto",
}
